/* Copyright(C) 2011 Cobac.Net All rights reserved. */

/* œK͂ăRpCĂ i5-3ߎQƁj*/

#include "system.h"
#include "io.h"
#define MAX 4600000

unsigned char  seg7dec( int );

int main()
{
    int i, sw, time=0;

    while (1) {
        IOWR_8DIRECT(MYPIO32_0_BASE, 0, seg7dec((time%60)%10));
        IOWR_8DIRECT(MYPIO32_0_BASE, 1, seg7dec((time%60)/10));
        IOWR_8DIRECT(MYPIO32_0_BASE, 2, seg7dec((time/60)%10) & 0x7F);
        IOWR_8DIRECT(MYPIO32_0_BASE, 3, seg7dec(time/600));
        sw = IORD_8DIRECT(MYPIO32_0_BASE, 4);
        if ( sw & 0x01 )
            time = 0;
        else {
            if ( sw & 0x02 ) {
                time += 60;
                if ( time >= 3600 )
                    time %= 60;
            }
            else {
                if ( ++time >= 3600 )
                    time = 0;
            }
            for ( i=0; i<MAX; i++);
        }
    }
    return 0;
}

unsigned char seg7dec( int in )
{
    unsigned char out;
    switch ( in ) {
        case 0x0: out = 0xc0; break;
        case 0x1: out = 0xf9; break;
        case 0x2: out = 0xa4; break;
        case 0x3: out = 0xb0; break;
        case 0x4: out = 0x99; break;
        case 0x5: out = 0x92; break;
        case 0x6: out = 0x82; break;
        case 0x7: out = 0xd8; break;
        case 0x8: out = 0x80; break;
        case 0x9: out = 0x90; break;
        default:  out = 0xff; break;
    }
    return out;
}
